-- Warborg is Wargames playing on network
-- Copyright (C) 2011 Manuel De Girardi

-- This Program is Free Software: You Can Redistribute It and/or Modify
-- It Under The Terms of The GNU General Public License As Published By
-- The Free Software Foundation, Either Version 3 of The License, or
-- (at Your Option) Any Later Version.

-- This Program is Distributed in The Hope That It Will Be Useful,
-- But WITHOUT ANY WARRANTY; Without Even The Implied Warranty of
-- MERCHANTABILITY or FITNESS for A PARTICULAR PURPOSE.  See The
-- GNU General Public License for More Details.

-- You Should Have Received A Copy of The GNU General Public License
-- Along with This Program.  if not, See <Http://Www.Gnu.Org/Licenses/>.


package body Warborg.Database is
   
   Charge_Factor : constant Float := 125.0;
   
   
   function "<" (Left, Right : in Missile_Type) return Boolean is
   begin
      return (Left.Missile_Attributes.Source.X < Right.Missile_Attributes.Source.X) and (Left.Missile_Attributes.Source.Y < right.Missile_Attributes.Source.Y);
   end "<";
   
   package Sorting_Vector is new Generic_Sorting("<");

   
   protected body Sgbd_Type is


      entry Get_Wopr(Logname : in String;
                     Wopr : out Wopr_Type;
                     Success : out boolean) when Allway is
      begin
         Wopr_List.Current := Wopr_List.Root;
         Success := False;
         while Wopr_List.Current /= null loop
            if Wopr_List.Current.Player_Name.all = Logname then
               Wopr := Wopr_List.Current.Wopr;
               Success := True;
               exit;
            end if;
            Wopr_List.Current := Wopr_List.Current.Next;
         end loop;
      end Get_Wopr;

      entry Add_Wopr(Logname : in String;
                     Wopr : in Wopr_Type;
                     Success : out boolean) when Allway is
      begin
         Success := False;
         declare
            New_Element : Node_Access := new Node_Type ' (new String ' (Logname),
                                                          Wopr,
                                                          null); --,

         begin
            if Wopr_List.Root /= null then

               Wopr_List.Current := Wopr_List.Root;
               while Wopr_List.Current.Next /= null loop

                  Wopr_List.Current :=  Wopr_List.Current.Next;
               end loop;

               Wopr_List.Current.next := New_Element;
            else
               Wopr_List.Root := New_Element;
               Wopr_List.Current := Wopr_List.Root;


            end if;
         end;
         Wopr_List.Nbr := Wopr_List.Nbr + 1;
         Success := True;
      end Add_Wopr;

      
      entry Get_Enemy(Logname : in String;
                      Missiles : out Missiles_Vectors.Vector) when Allway is
	 
	 
	 Temp : Missiles_Vectors.Vector;
	   
      begin

         Wopr_List.Current := Wopr_List.Root;
         while Wopr_List.Current /= null  Loop

            if Wopr_List.Current.Player_Name.all /= Logname then
	       
               temp := temp & Wopr_List.Current.Wopr.Missiles;

            end if;

            Wopr_List.Current := Wopr_List.Current.Next;
         end loop;
	 
	 Sorting_Vector.Sort(temp);
	 if not Is_Empty(Temp) then
	    for I in 1..Extended_Index'Min(40000, Last_Index(Temp)) loop
	       Missiles := Missiles & Element(Temp, I);
	    end loop;
	 end if;
	 
	 
	 
	 
      end Get_Enemy;

      entry Add_Missile(Logname : in String;
                        Missile : in Missile_Type;
                        Success : out Boolean) when Allway is
      begin
         Success := False;


         Wopr_List.Current := Wopr_List.Root;
         if Wopr_List.Current.Player_Name.all = Logname then

            Missiles_Vectors.Insert(Wopr_List.Current.Wopr.Missiles,
                                    Missiles_Vectors.Last_index(Wopr_List.Current.Wopr.Missiles) + 1, Missile, 1);
            Success := True;
         else
            while Wopr_List.Current.Next /= null loop
               Wopr_List.Current := Wopr_List.Current.Next;
               if Wopr_List.Current.Player_Name.all = Logname then

                  Missiles_Vectors.Insert(Wopr_List.Current.Wopr.missiles,
                                          Missiles_Vectors.Last_index(Wopr_List.Current.Wopr.Missiles) + 1, Missile, 1);
                  Success := True;

                  exit;
               end if;

            end loop;
         end if;
      end Add_Missile;

      entry Launch_One(Logname : in String;
                       Missile_Id : in Missile_Vector_Index_type) when Allway is


      begin
         Loose := False;
         Back := 0;
         Wopr_List.Current := Wopr_List.Root;


         while Wopr_List.Current /= null loop
            if Wopr_List.Current.Player_Name.all = Logname then

               if not Missiles_Vectors.Is_Empty(Wopr_List.Current.Wopr.Missiles) then


                  Launched_Missile_Attributes :=
                    Missiles_Vectors.Element(Wopr_List.Current.Wopr.Missiles, Missile_Id).Missile_attributes;


                  Missiles_Vectors.Delete(Wopr_List.Current.Wopr.Missiles, Missile_Id, 1);



                  Temp := Wopr_List.Root;
                  while Temp /= null loop

                     if not Missiles_Vectors.Is_Empty(Temp.Wopr.Missiles) then

                        for L in 1..Missiles_Vectors.Last_Index(Temp.Wopr.Missiles) loop
                           Missile_Attributes :=
                             Missiles_Vectors.Element(temp.Wopr.Missiles,
                                                      Missile_Vector_Index_Type(Natural(L) -
                                                                                  Back)).Missile_attributes;

                           if (Missile_Attributes.Source.X >=
                                 Launched_Missile_Attributes.Target.X -
                                 Launched_Missile_Attributes.Charge * Charge_Factor and
                                 Missile_Attributes.Source.X <=
                                 Launched_Missile_Attributes.Target.X +
                                 Launched_Missile_Attributes.Charge * Charge_Factor) and
                             (Missile_Attributes.Source.Y >=
                                Launched_Missile_Attributes.Target.Y -
                                Launched_Missile_Attributes.Charge * Charge_Factor and
                                Missile_Attributes.Source.Y <=
                                Launched_Missile_Attributes.Target.Y +
                                Launched_Missile_Attributes.Charge * Charge_Factor) then
                              if not Loose then
                                 Loose := True;
                              end if;
                              Missiles_Vectors.delete(Temp.Wopr.Missiles,
                                                      Missile_Vector_Index_Type(Natural(L) - Back), 1);
			      
			      Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Missiles := Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Missiles + 1;
                              Back := Back + 1;
                           end if;


                        end loop;
                        Back := 0;

                     end if;

                     Wopr_Attributes := Temp.Wopr.Wopr_Attributes;

                     if (Wopr_Attributes.Source.X >=
                           Launched_Missile_Attributes.Target.X -
                           Launched_Missile_Attributes.Charge * Charge_Factor and
                           Wopr_Attributes.Source.X <=
                           Launched_Missile_Attributes.Target.X +
                           Launched_Missile_Attributes.Charge * Charge_Factor) and
                       (Wopr_Attributes.Source.Y >=
                          Launched_Missile_Attributes.Target.Y -
                          Launched_Missile_Attributes.Charge * Charge_Factor and
                          Wopr_Attributes.Source.Y <=
                          Launched_Missile_Attributes.Target.Y +
                          Launched_Missile_Attributes.Charge * Charge_Factor) then

                        Loose := False;
			

                        Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Wopr :=
                          Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Wopr + 1;
                        Wopr_List.Current.Wopr.Wopr_Attributes.Earned_Missiles :=
                          Wopr_List.Current.Wopr.Wopr_Attributes.Earned_Missiles +
                          Natural(Last_Index(Temp.Wopr.Missiles));

                        if not Missiles_Vectors.Is_Empty(Temp.Wopr.Missiles) Then
                           Local := local & Temp.Wopr.Missiles;
                           Missiles_Vectors.Clear(Temp.Wopr.Missiles);
                        end if;

                        if Temp = Wopr_List.Root then

                           if Wopr_List.Root.Next /= null then

                              Wopr_List.Root := Wopr_List.Root.Next;
                              Temp := Wopr_List.root;
                           else

                              Wopr_List.Root := null;
                              Temp := null;
                              Wopr_List.Current := null;
                           end if;

                        else

                           Prev.next := Temp.Next;
                           Temp := Prev.Next;
                        end if;
                        Wopr_List.Nbr := Wopr_List.Nbr - 1;




                     else

                        Prev := Temp;
                        Temp := Temp.Next;

                     end if;

                     if Loose then
                        Loose := False;
                     end if;

                  end loop;


                  if Wopr_List.Current /= null then
                     Clear(Wopr_List.Current.Wopr.Missiles);
                     Wopr_List.Current.Wopr.Missiles :=
                       Wopr_List.Current.Wopr.Missiles & Local;
                  end if;

               end if;

               exit;
            end if;
            Wopr_List.Current := Wopr_List.Current.Next;
         end loop;
      end Launch_One;

      entry Launch_All(Logname : in String) when Allway is


      begin
         Wopr_List.Current := Wopr_List.Root;



         while Wopr_List.Current /= null loop
            if Wopr_List.Current.Player_Name.all = Logname then

               if not Missiles_Vectors.Is_Empty(Wopr_List.Current.Wopr.Missiles) then

              Main :
                  while Missiles_Vectors.Last_Index(Wopr_List.Current.Wopr.Missiles) /= 0 loop
                     Launched_Missile_Attributes :=
                       Element(Wopr_List.Current.Wopr.Missiles, 1).Missile_attributes;
                     delete(Wopr_List.Current.Wopr.Missiles, 1, 1);

                     Temp := Wopr_List.root;
                     while Temp /= null loop

                        if not Is_Empty(Temp.Wopr.Missiles) then

                           for L in 1..Last_Index(Temp.Wopr.Missiles) loop
                              Missile_Attributes :=
                                Element(temp.Wopr.Missiles,
                                        Missile_Vector_Index_Type(Natural(L) - Back)).Missile_attributes;

                              if (Missile_Attributes.Source.X >=
                                    Launched_Missile_Attributes.Target.X -
                                    Launched_Missile_Attributes.Charge * Charge_Factor and
                                    Missile_Attributes.Source.X <=
                                    Launched_Missile_Attributes.Target.X +
                                    Launched_Missile_Attributes.Charge * Charge_Factor) and
                                (Missile_Attributes.Source.Y >=
                                   Launched_Missile_Attributes.Target.Y -
                                   Launched_Missile_Attributes.Charge * Charge_Factor and
                                   Missile_Attributes.Source.Y <=
                                   Launched_Missile_Attributes.Target.Y +
                                   Launched_Missile_Attributes.Charge * Charge_Factor) then
                                 if not Loose then
                                    Loose := True;
                                 end if;
                                 delete(Temp.Wopr.Missiles,
                                        Missile_Vector_Index_Type(Natural(L) - Back), 1);
				 Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Missiles := Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Missiles + 1;
                                 Back := Back + 1;
                              end if;
			      
                           end loop;
                           Back := 0;

                        end if;

                        Wopr_Attributes := Temp.Wopr.Wopr_Attributes;

                        if (Wopr_Attributes.Source.X >=
                              Launched_Missile_Attributes.Target.X -
                              Launched_Missile_Attributes.Charge * Charge_Factor and
                              Wopr_Attributes.Source.X <=
                              Launched_Missile_Attributes.Target.X +
                              Launched_Missile_Attributes.Charge * Charge_Factor) and
                          (Wopr_Attributes.Source.Y >=
                             Launched_Missile_Attributes.Target.Y -
                             Launched_Missile_Attributes.Charge * Charge_Factor and
                             Wopr_Attributes.Source.Y <=
                             Launched_Missile_Attributes.Target.Y +
                             Launched_Missile_Attributes.Charge * Charge_Factor) then




                           Loose := False;

                           Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Wopr :=
                             Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Wopr + 1;
                           Wopr_List.Current.Wopr.Wopr_Attributes.Earned_Missiles :=
                             Wopr_List.Current.Wopr.Wopr_Attributes.Earned_Missiles +
                             Natural(Last_Index(Local));
                           if not Is_Empty(Temp.Wopr.Missiles) Then
                              Local := local & Temp.Wopr.Missiles;
                              Clear(Temp.Wopr.Missiles);
                           end if;

                           if Temp = Wopr_List.Root then

                              if Wopr_List.Root.Next /= null then

                                 Wopr_List.Root := Wopr_List.Root.Next;
                                 Temp := Wopr_List.Root;
                                 Wopr_List.Nbr := Wopr_List.Nbr - 1;
                                 if Loose then
                                    Loose := False;
                                 end if;
                              else

                                 Wopr_List.Root := null;
                                 Temp := null;
                                 Wopr_List.Current := null;
                                 Wopr_List.Nbr := Wopr_List.Nbr - 1;
                                 if Loose then
                                    Loose := False;
                                 end if;
                                 exit Main;

                              end if;

                           else


                              Prev.next := Temp.Next;
                              Temp := Prev.Next;
                              Wopr_List.Nbr := Wopr_List.Nbr - 1;
                              if Loose then
                                 Loose := False;
                              end if;
                           end if;





                        else

                           Prev := Temp;
                           Temp := Temp.Next;

                        end if;



                     end loop;
                  end loop main;



                  if Wopr_List.Current /= null then
                     Clear(Wopr_List.Current.Wopr.Missiles);
                     Wopr_List.Current.Wopr.Missiles := Local;
                  end if;

                  Clear(Local);
               end if;

               exit;
            end if;
            Wopr_List.Current := Wopr_List.Current.Next;
         end loop;

      end Launch_All;
   end Sgbd_Type;


end Warborg.Database;
